#ifndef _WINDOWS_PLAYM4_H_
#define _WINDOWS_PLAYM4_H_

#if defined( _WINDLL)
    #define PLAYM4_API  extern "C" __declspec(dllexport)
#else 
    #define PLAYM4_API  extern "C" __declspec(dllimport)
#endif

//Max channel numbers
#define PLAYM4_MAX_SUPPORTS 500
//Wave coef range;
#define MIN_WAVE_COEF -100
#define MAX_WAVE_COEF 100

//Timer type
#define TIMER_1 1 //Only 16 timers for every process.Default TIMER;
#define TIMER_2 2 //Not limit;But the precision less than TIMER_1;

//BUFFER AND DATA TYPE
#define BUF_VIDEO_SRC               (1) //mixed input,total src buffer size;splited input,video src buffer size 
#define BUF_AUDIO_SRC               (2) //mixed input,not defined;splited input,audio src buffer size
#define BUF_VIDEO_RENDER            (3) //video render node count 
#define BUF_AUDIO_RENDER            (4) //audio render node count 
#define BUF_VIDEO_DECODED           (5) //video decoded node count to render
#define BUF_AUDIO_DECODED           (6) //audio decoded node count to render
#define BUF_VIDEO_SRC_EX            (7) //video render node count without hangnode;resetbuf need

//Error code
#define  PLAYM4_NOERROR                         0   //no error
#define  PLAYM4_PARA_OVER                       1   //input parameter is invalid;
#define  PLAYM4_ORDER_ERROR                     2   //The order of the function to be called is error.
#define  PLAYM4_TIMER_ERROR                     3   //Create multimedia clock failed;
#define  PLAYM4_DEC_VIDEO_ERROR                 4   //Decode video data failed.
#define  PLAYM4_DEC_AUDIO_ERROR                 5   //Decode audio data failed.
#define  PLAYM4_ALLOC_MEMORY_ERROR              6   //Allocate memory failed.
#define  PLAYM4_OPEN_FILE_ERROR                 7   //Open the file failed.
#define  PLAYM4_CREATE_OBJ_ERROR                8   //Create thread or event failed
#define  PLAYM4_CREATE_DDRAW_ERROR              9   //Create DirectDraw object failed.
#define  PLAYM4_CREATE_OFFSCREEN_ERROR          10  //failed when creating off-screen surface.
#define  PLAYM4_BUF_OVER                        11  //buffer is overflow
#define  PLAYM4_CREATE_SOUND_ERROR              12  //failed when creating audio device.	
#define  PLAYM4_SET_VOLUME_ERROR                13  //Set volume failed
#define  PLAYM4_SUPPORT_FILE_ONLY               14  //The function only support play file.
#define  PLAYM4_SUPPORT_STREAM_ONLY             15  //The function only support play stream.
#define  PLAYM4_SYS_NOT_SUPPORT                 16  //System not support.
#define  PLAYM4_FILEHEADER_UNKNOWN              17  //No file header.
#define  PLAYM4_VERSION_INCORRECT               18  //The version of decoder and encoder is not adapted.  
#define  PLAYM4_INIT_DECODER_ERROR              19  //Initialize decoder failed.
#define  PLAYM4_CHECK_FILE_ERROR                20  //The file data is unknown.
#define  PLAYM4_INIT_TIMER_ERROR                21  //Initialize multimedia clock failed.
#define  PLAYM4_BLT_ERROR                       22  //Blt failed.
#define  PLAYM4_UPDATE_ERROR                    23  //Update failed.
#define  PLAYM4_OPEN_FILE_ERROR_MULTI           24  //openfile error, streamtype is multi
#define  PLAYM4_OPEN_FILE_ERROR_VIDEO           25  //openfile error, streamtype is video
#define  PLAYM4_JPEG_COMPRESS_ERROR             26  //JPEG compress error
#define  PLAYM4_EXTRACT_NOT_SUPPORT             27  //Don't support the version of this file.
#define  PLAYM4_EXTRACT_DATA_ERROR              28  //extract video data failed.
#define  PLAYM4_SECRET_KEY_ERROR                29  //Secret key is error //add 20071218
#define  PLAYM4_DECODE_KEYFRAME_ERROR           30  //add by hy 20090318
#define  PLAYM4_NEED_MORE_DATA                  31  //add by hy 20100617
#define  PLAYM4_INVALID_PORT                    32  //add by cj 20100913
#define  PLAYM4_NOT_FIND                        33  //add by cj 20110428
#define  PLAYM4_NEED_LARGER_BUFFER              34  //add by pzj 20130528
#define  PLAYM4_FAIL_UNKNOWN                    99  //Fail, but the reason is unknown;	

//۹ܴ
#define PLAYM4_FEC_ERR_ENABLEFAIL               100 // ģʧ
#define PLAYM4_FEC_ERR_NOTENABLE                101 // ģûм
#define PLAYM4_FEC_ERR_NOSUBPORT                102 // Ӷ˿ûз
#define PLAYM4_FEC_ERR_PARAMNOTINIT             103 // ûгʼӦ˿ڵĲ
#define PLAYM4_FEC_ERR_SUBPORTOVER              104 // Ӷ˿Ѿ
#define PLAYM4_FEC_ERR_EFFECTNOTSUPPORT         105 // ðװʽЧ֧
#define PLAYM4_FEC_ERR_INVALIDWND               106 // ǷĴ
#define PLAYM4_FEC_ERR_PTZOVERFLOW              107 // PTZλԽ
#define PLAYM4_FEC_ERR_RADIUSINVALID            108 // ԲĲǷ
#define PLAYM4_FEC_ERR_UPDATENOTSUPPORT         109 // ָİװʽͽЧò²֧
#define PLAYM4_FEC_ERR_NOPLAYPORT               110 // ſ˿û
#define PLAYM4_FEC_ERR_PARAMVALID               111 // Ϊ
#define PLAYM4_FEC_ERR_INVALIDPORT              112 // ǷӶ˿
#define PLAYM4_FEC_ERR_PTZZOOMOVER              113 // PTZΧԽ
#define PLAYM4_FEC_ERR_OVERMAXPORT              114 // ֵ֧ͨͣĽͨΪ64
#define PLAYM4_FEC_ERR_ENABLED                  115 // ö˿Ѿģ
#define PLAYM4_FEC_ERR_D3DACCENOTENABLE         116 // D3Dûп
#define PLAYM4_FEC_ERR_PLACETYPE                117 // װʽ.һſportӦһְװʽ
#define PLAYM4_FEC_ERR_CorrectType              118 // ʽʽ,ܿһſport,趨PTZ۰ʽ,Ľʽֻܿһ·;180Ƚܺptzһ𿪣޹ԡ
#define PLAYM4_FEC_ERR_NULLWND                  119 // ۴Ϊ
#define PLAYM4_FEC_ERR_PARA                     120 // ۲


//Max display regions.
#define MAX_DISPLAY_WND     4

//Display type
#define DISPLAY_NORMAL      0x00000001
#define DISPLAY_QUARTER     0x00000002
#define DISPLAY_YC_SCALE    0x00000004
#define DISPLAY_NOTEARING   0x00000008

//Display buffers
#define MAX_DIS_FRAMES      50
#define MIN_DIS_FRAMES      1

//Locate by
#define BY_FRAMENUM         1
#define BY_FRAMETIME        2

//Source buffer
#define SOURCE_BUF_MAX      1024*100000
#define SOURCE_BUF_MIN      1024*50

//Stream type
#define STREAME_REALTIME    0
#define STREAME_FILE        1

//frame type
#define T_AUDIO16           101
#define T_AUDIO8            100
#define T_UYVY              1
#define T_YV12              3
#define T_RGB32             7

//capability
#define SUPPORT_DDRAW       1
#define SUPPORT_BLT         2
#define SUPPORT_BLTFOURCC   4
#define SUPPORT_BLTSHRINKX  8
#define SUPPORT_BLTSHRINKY  16
#define SUPPORT_BLTSTRETCHX 32
#define SUPPORT_BLTSTRETCHY 64
#define SUPPORT_SSE         128
#define SUPPORT_MMX         256

// º궨HIK_MEDIAINFOṹ
#define FOURCC_HKMI         0x484B4D49  // "HKMI" HIK_MEDIAINFOṹ

// ϵͳװʽ
#define SYSTEM_NULL         0x0         // ûϵͳ㣬ƵƵ
#define SYSTEM_HIK          0x1         // ļ
#define SYSTEM_MPEG2_PS     0x2         // PSװ
#define SYSTEM_MPEG2_TS     0x3         // TSװ
#define SYSTEM_RTP          0x4         // rtpװ
#define SYSTEM_MPEG4        0x5         ///< MP4װ
#define SYSTEM_AVI          0x7         ///< AVIװ
#define SYSTEM_RTMP         0xD         // rtmpװ
#define SYSTEM_RTPHIK       0x401       // rtpװhik
#define SYSTEM_RTP_JT       0x104       // rtpjtװ
#define SYSTEM_DAH          0x8001      // 󻪷װ


// Ƶ
#define VIDEO_NULL          0x0 // ûƵ
#define VIDEO_H264          0x1 // H.264
#define VIDEO_MPEG2         0x2 // ׼MPEG2
#define VIDEO_MPEG4         0x3 // ׼MPEG4
#define VIDEO_MJPEG         0x4
#define VIDEO_AVC265        0x5 // ׼H265/AVC
#define VIDEO_SVAC          0x6
#define VIDEO_AVC264        0x0100

// Ƶ
#define AUDIO_NULL          0x0000 // ûƵ
#define AUDIO_ADPCM         0x1000 // ADPCM
#define AUDIO_MPEG          0x2000 // MPEG ϵƵӦMPEGƵ
#define AUDIO_AAC           0X2001 // AAC 
#define AUDIO_RAW_DATA8     0x7000 //Ϊ8kԭʼ
#define AUDIO_RAW_UDATA16   0x7001 //Ϊ16kԭʼݣL16
// GϵƵ
#define AUDIO_RAW_DATA8     0x7000      //Ϊ8kԭʼ
#define AUDIO_RAW_UDATA16   0x7001      //Ϊ16kԭʼݣL16
#define AUDIO_G711_U        0x7110
#define AUDIO_G711_A        0x7111
#define AUDIO_G722_1        0x7221
#define AUDIO_G723_1        0x7231
#define AUDIO_G726_U        0x7260
#define AUDIO_G726_A        0x7261
#define AUDIO_G726_16       0x7262
#define AUDIO_G729          0x7290
#define AUDIO_AMR_NB        0x3000

#define SYNCDATA_VEH        1 //ͬ:Ϣ
#define SYNCDATA_IVS        2 //ͬ:Ϣ

//motion flow type
#define	MOTION_FLOW_NONE    0
#define MOTION_FLOW_CPU     1
#define MOTION_FLOW_GPU     2

//Ƶ
#define ENCRYPT_AES_3R_VIDEO     1
#define ENCRYPT_AES_10R_VIDEO    2
#define ENCRYPT_AES_3R_AUDIO     1
#define ENCRYPT_AES_10R_AUDIO    2

///<תǶ
#define R_ANGLE_0           -1      //ת
#define R_ANGLE_L90         0       //ת90
#define R_ANGLE_R90         1       //ת90
#define R_ANGLE_180         2       //ת180


//Frame position
typedef struct{
    LONGLONG nFilePos;
    long nFrameNum;
    long nFrameTime;
    long nErrorFrameNum;
    SYSTEMTIME *pErrorTime;
    long nErrorLostFrameNum;
    long nErrorFrameSize;
}FRAME_POS,*PFRAME_POS;

//Frame Info
typedef struct{
    long nWidth;
    long nHeight;
    long nStamp;
    long nType;
    long nFrameRate;
    DWORD dwFrameNum;
}FRAME_INFO;

//Frame 
typedef struct{
    char *pDataBuf;
    long  nSize;
    long  nFrameNum;
    BOOL  bIsAudio;
    long  nReserved;
}FRAME_TYPE;

//Watermark Info
typedef struct{
    char *pDataBuf;
    long  nSize;
    long  nFrameNum;
    BOOL  bRsaRight;
    long  nReserved;
}WATERMARK_INFO;

typedef struct SYNCDATA_INFO 
{
    DWORD dwDataType;       //ͬĸϢͣĿǰУϢϢ
    DWORD dwDataLen;        //Ϣݳ
    BYTE* pData;            //ָϢݽṹָ,IVS_INFOṹ
} SYNCDATA_INFO;

// չϢṹ
typedef struct
{
    unsigned char        privt_type;                     // ûչ:IVS_PRIVT_INFO10ʾɫ+ΥƷ
    unsigned char        reseverd[6];                    // Ŀչ
    unsigned char        privt_len;                      // ûչϢ
    unsigned char        privt_data[32];                 // ûչϢ
}IS_PRIVT_INFO;

// ɫṹ
typedef struct
{
    unsigned char red;
    unsigned char green;
    unsigned char blue;
    unsigned char alpha;
}IS_PRIVT_INFO_COLOR;

// Υɫṹ
typedef struct
{
    IS_PRIVT_INFO_COLOR color;                  // ɫ
    unsigned char       confidence;             // ΥƷŶ
    unsigned char       pos_len;                // ΥƷƳ
    unsigned char       pos_data[22];           // ΥƷ
    unsigned int        type;                   // ΥƷ
}IS_PRIVT_INFO_CONTRABAND;

typedef struct _VCA_RECT_F_
{
    float x;         //ϽX
    float y;         //ϽY
    float width;     //ο
    float height;    //θ߶
}VCA_RECT_F;

//ĿϢṹ
typedef struct _VCA_TARGET_EX
{
    unsigned int      ID;          //ID
    unsigned char     reserved[8]; //ֽ
    VCA_RECT_F        rect;        //Ŀ
    unsigned char     reserved1[40]; //˽ϢչֶΣʱunsigned charʾⲿٸ֪ṹϢ
}VCA_TARGET_EX;

typedef struct _VCA_TARGET_LIST_EX
{
    unsigned int    target_num;             //Ŀ
    VCA_TARGET_EX   *pstTarget;             //ĿݣVCA_TARGET_EXĴСƫƶȡĿϢ
}VCA_TARGET_LIST_EX;

//Ϣṹص
typedef struct _INTEL_INFO_EX
{
    unsigned int                   type;               ///< ǻصЩ˽Ϣ
    VCA_TARGET_LIST_EX             stTarget;           ///< Ŀ
    VCA_TARGET_LIST_EX             stTarget_EX;        ///< Ŀ
}INTEL_INFO_EX;
/////////////////////////////////////////////////////////////////////////////////////////////
//IVSϢصӿڽṹ嶨
/////////////////////////////////////////////////////////////////////////////////////////////

///                                Ŀ                           ///
typedef struct _VCA_POINT_F_
{
    float x;
    float y;
}VCA_POINT_F;

//()
typedef struct _VCA_POLYGON_F_
{
    unsigned int  vertex_num;                  //
    VCA_POINT_F   point[10];   //
}VCA_POLYGON_F;

//ת
typedef struct _VCA_ROTATE_RECT_F_
{
    float				  cx;						// ĵX
    float				  cy;						// ĵY
    float				  width;					// ο
    float				  height;					// θ߶
    float				  theta;				   // תνǶ
}VCA_ROTATE_RECT_F;

//
typedef struct _VCA_REGION_
{
    unsigned int region_type;           // οVCA_REGION_TYPE2ʾΣ3ʾ
    char         reserved[12];
    union
    {
        unsigned char		size[84];
        VCA_POLYGON_F       polygon;                // 
        VCA_RECT_F          rect;                   // 
        VCA_ROTATE_RECT_F 	rotate_rect;	 		 // ת,ݲ֧
    };
}VCA_REGION;

//Ŀṹ
typedef struct 
{
    unsigned int            id;
    unsigned int            blob_type;        // Ŀ_OBJ_TYPE
    short                   confidence;       // ĿŶ
    char                    reserved[14];
    VCA_REGION              region;           // Ŀλ
    unsigned char           privt_info[40];   // չϢ
}HIK_TARGET_BLOB_EX;

//ĿбϢ壺
typedef struct _VCA_TARGET_LIST_V1_EX_
{
    unsigned int         LineType;      //ͣ0ʾο1ʾĽǿ
    unsigned int         target_num;    //Ŀ
    HIK_TARGET_BLOB_EX   *pstTarget;    //ĿݣHIK_TARGET_BLOB_EXĴСƫƶȡĿϢ
}VCA_TARGET_LIST_V1_EX;

///                                                           ///
//ṹ
typedef struct _VCA_RULE_EX
{
    unsigned char       ID;               //ID
    unsigned char       reserved[15];       //ֽ
    VCA_POLYGON_F       polygon;         //ӦĶ
    unsigned char       privt_info[40];      // չϢ
}VCA_RULE_EX;

//бϢ壺
typedef struct _VCA_RULE_LIST_V3_EX_
{
    unsigned int  LineType;      //ͣ0ʾο1 ʾĽǿ
    unsigned int  rule_num;     //й
    VCA_RULE_EX   *pstRule;   //ݣVCA_RULE_EXĴСƫƶȡĿϢ
}VCA_RULE_LIST_V3_EX;

///                                                           ///

typedef struct  _VCA_ALERT_EX_
{
    unsigned char     alert;           //ޱϢ: 0-ûУ1-
    unsigned char     reserved[7];     //ֽ
    VCA_RULE_EX       rule_info;       //Ϣ
    VCA_TARGET_EX        target;          //ĿϢ
    unsigned char     privt_info[40];  // չϢ
}VCA_ALERT_EX;

//Ϣ壺
typedef struct  _VCA_ALERT_LIST_EX_
{
    unsigned int           alert_num;  //
    VCA_ALERT_EX           *pstAlert; 
}VCA_ALERT_LIST_EX;

//Ϣ
typedef struct  _VCA_INTEL_INFO_
{
    unsigned int   nDataLen;        //Ϣݳ
    unsigned char  *pData;          //ָϢݽṹָ
}VCA_INTEL_INFO;

//Ϣṹص
typedef struct _PRIVATE_INFO_
{
    unsigned int                  type;      ///< ǻصЩ˽Ϣ
    VCA_TARGET_LIST_V1_EX         stTarget;           ///< ͨĿ 1
    VCA_TARGET_LIST_V1_EX         stTarget_EX;        ///< Ŀ 2
    VCA_RULE_LIST_V3_EX           stRule;             ///< ͨ 4
    VCA_RULE_LIST_V3_EX           stRule_EX;          ///<  8
    VCA_ALERT_LIST_EX             stAlert;            ///< Ϣ 16
    VCA_INTEL_INFO                stTempInfo;         ///< Ϣ 32
} PRIVATE_INFO;

/////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _HIK_MEDIAINFO_FLAG_
#define _HIK_MEDIAINFO_FLAG_
typedef struct _HIK_MEDIAINFO_
{
    unsigned int    media_fourcc;           // "HKMI": 0x484B4D49 Hikvision Media Information
    unsigned short  media_version;          // 汾ţָϢṹ汾ţĿǰΪ0x0101,1.01汾01汾ţ01Ӱ汾š
    unsigned short  device_id;              // 豸IDڸ/
    unsigned short  system_format;          // ϵͳװ
    unsigned short  video_format;           // Ƶ
    unsigned short  audio_format;           // Ƶ
    unsigned char   audio_channels;         // ͨ  
    unsigned char   audio_bits_per_sample;  // λ
    unsigned int    audio_samplesrate;      //  
    unsigned int    audio_bitrate;          // ѹƵ,λbit
    unsigned int    reserved[4];            // 
}HIK_MEDIAINFO;
#endif

typedef struct
{
    long nPort;
    char * pBuf;
    long nBufLen;
    long nWidth;
    long nHeight;
    long nStamp;
    long nType;
    void* nUser;
}DISPLAY_INFO;

typedef struct
{
    long nPort;
    char *pVideoBuf;
    long nVideoBufLen;
    char *pPriBuf;
    long nPriBufLen;
    long nWidth;
    long nHeight;
    long nStamp;
    long nType;
    void* nUser;
}DISPLAY_INFOEX;

typedef struct
{
    long         nPort;        //ͨ
    char         *pBuf;        //صĵһ·ͼָ
    unsigned int nBufLen;      //صĵһ·ͼݴС
    char         *pBuf1;       //صĵڶ·ͼָ
    unsigned int nBufLen1;     //صĵڶ·ͼݴС
    char         *pBuf2;       //صĵ·ͼָ
    unsigned int nBufLen2;     //صĵ·ͼݴС
    unsigned int nWidth;       //
    unsigned int nHeight;      //
    unsigned int nStamp;       //ʱϢλ
    unsigned int nType;        //
    void         *pUser;       //û
    unsigned int reserved[4];  //
}DISPLAY_INFO_YUV;

typedef struct PLAYM4_SYSTEM_TIME //ʱ
{
    DWORD dwYear;   //
    DWORD dwMon;    //
    DWORD dwDay;    //
    DWORD dwHour;   //ʱ
    DWORD dwMin;    //
    DWORD dwSec;    //
    DWORD dwMs;     //
} PLAYM4_SYSTEM_TIME;

#ifndef CROP_PIC_INFO_TAG
#define CROP_PIC_INFO_TAG
typedef struct
{
    BYTE  *pDataBuf;      //ץͼbuffer
    DWORD dwPicSize;      //ʵͼƬС
    DWORD dwBufSize;      //bufferС
    DWORD dwPicWidth;     //ͼ
    DWORD dwPicHeight;    //ͼ
    DWORD dwReserve;      //һreserveֶ
    RECT  *pCropRect;     //ѡNULL, ͬϵץͼӿ
}CROP_PIC_INFO;
#endif

//ENCRYPT Info
typedef struct{
    long nVideoEncryptType;  //Ƶ
    long nAudioEncryptType;  //Ƶ
    long nSetSecretKey;      //Ƿã1ʾԿ0ʾûԿ
}ENCRYPT_INFO;

///<˽Ϣģ
typedef enum _PLAYM4_PRIDATA_RENDER
{
    PLAYM4_RENDER_ANA_INTEL_DATA    = 0x00000001, //ܷ
    PLAYM4_RENDER_MD                = 0x00000002, //ƶ
    PLAYM4_RENDER_ADD_POS           = 0x00000004, //POSϢ
    PLAYM4_RENDER_ADD_PIC           = 0x00000008, //ͼƬϢ
    PLAYM4_RENDER_FIRE_DETCET       = 0x00000010, //ȳϢ
    PLAYM4_RENDER_TEM               = 0x00000020, //¶Ϣ
    PLAYM4_RENDER_TRACK_TEM         = 0x00000040, //켣Ϣ
    PLAYM4_RENDER_THERMAL           = 0x00000080, //̻Ϣ
}PLAYM4_PRIDATA_RENDER;

typedef enum _PLAYM4_THERMAL_FLAG
{
    PLAYM4_THERMAL_FIREMASK           = 0x00000001, //̻
    PLAYM4_THERMAL_RULEGAS            = 0x00000002, //⣨屨⸴ù
    PLAYM4_THERMAL_TARGETGAS          = 0x00000004, //Ŀ
    PLAYM4_THERMAL_ALERTTARGETGAS     = 0x00000008, //屨Ŀ
}PLAYM4_THERMAL_FLAG;

typedef enum _PLAYM4_FIRE_ALARM
{
    PLAYM4_FIRE_FRAME_DIS           = 0x00000001, //ʾ
    PLAYM4_FIRE_MAX_TEMP            = 0x00000002, //¶
    PLAYM4_FIRE_MAX_TEMP_POSITION   = 0x00000004, //¶λʾ
    PLAYM4_FIRE_DISTANCE            = 0x00000008, //¶Ⱦ
}PLAYM4_FIRE_ALARM;

typedef enum _PLAYM4_TEM_FLAG
{
    PLAYM4_TEM_REGION_BOX             = 0x00000001, //
    PLAYM4_TEM_REGION_LINE            = 0x00000002, //߲
    PLAYM4_TEM_REGION_POINT           = 0x00000004, //
}PLAYM4_TEM_FLAG;

typedef enum _PLAYM4_TRACK_FLAG
{
    PLAYM4_TRACK_PEOPLE               = 0x00000001, //˹켣
    PLAYM4_TRACK_VEHICLE              = 0x00000002, //켣
}PLAYM4_TRACK_FLAG;

/////////////////////////////////////////////////////////////////////////////////////////////
//Proposed Interface ʹõĽӿ
/////////////////////////////////////////////////////////////////////////////////////////////
///<ʼ
PLAYM4_API BOOL __stdcall PlayM4_GetPort(LONG* nPort);
PLAYM4_API BOOL __stdcall PlayM4_FreePort(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_OpenFile(LONG nPort,LPSTR sFileName);
PLAYM4_API BOOL __stdcall PlayM4_CloseFile(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_OpenStream(LONG nPort,PBYTE pFileHeadBuf,DWORD nSize,DWORD nBufPoolSize);
PLAYM4_API BOOL __stdcall PlayM4_CloseStream(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_InputData(LONG nPort,PBYTE pBuf,DWORD nSize);
PLAYM4_API BOOL __stdcall PlayM4_SetStreamOpenMode(LONG nPort,DWORD nMode);
PLAYM4_API LONG __stdcall PlayM4_GetStreamOpenMode(LONG nPort);

///<
PLAYM4_API BOOL __stdcall PlayM4_SetFileRefCallBack(LONG nPort, void (__stdcall *pFileRefDone)(DWORD nPort,void* nUser),void* nUser);
PLAYM4_API BOOL __stdcall PlayM4_GetRefValue(LONG nPort,BYTE *pBuffer, DWORD *pSize);
PLAYM4_API BOOL __stdcall PlayM4_SetRefValue(LONG nPort,BYTE *pBuffer, DWORD nSize);
PLAYM4_API BOOL __stdcall PlayM4_GetRefValueEx(LONG nPort,BYTE *pBuffer, DWORD *pSize);///< PlayM4_GetRefValueExȣ֡ͺͳȻص
PLAYM4_API BOOL __stdcall PlayM4_GetKeyFramePos(LONG nPort,DWORD nValue, DWORD nType, PFRAME_POS pFramePos);
PLAYM4_API BOOL __stdcall PlayM4_GetNextKeyFramePos(LONG nPort,DWORD nValue, DWORD nType, PFRAME_POS pFramePos);

///<ſ
PLAYM4_API BOOL __stdcall PlayM4_Play(LONG nPort, HWND hWnd);
PLAYM4_API BOOL __stdcall PlayM4_Stop(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_Pause(LONG nPort,DWORD nPause);
PLAYM4_API BOOL __stdcall PlayM4_Fast(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_Slow(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_OneByOne(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_OneByOneBack(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_ReversePlay(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_RefreshPlay(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_RefreshPlayEx(LONG nPort,DWORD nRegionNum);

///<
PLAYM4_API BOOL __stdcall PlayM4_PlaySound(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_StopSound();
PLAYM4_API BOOL __stdcall PlayM4_PlaySoundShare(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_StopSoundShare(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_SetVolume(LONG nPort,WORD nVolume);
PLAYM4_API WORD __stdcall PlayM4_GetVolume(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_AdjustWaveAudio(LONG nPort,LONG nCoefficient);
PLAYM4_API BOOL	__stdcall PlayM4_SetANRParam(LONG nPort, BOOL nEnable, int nANRLevel);

///<ȡϢ
PLAYM4_API BOOL __stdcall PlayM4_SetPlayPos(LONG nPort,float fRelativePos);
PLAYM4_API float __stdcall PlayM4_GetPlayPos(LONG nPort);
PLAYM4_API DWORD __stdcall PlayM4_GetFileTime(LONG nPort);
PLAYM4_API DWORD __stdcall PlayM4_GetPlayedTime(LONG nPort);
PLAYM4_API DWORD __stdcall PlayM4_GetPlayedFrames(LONG nPort);
PLAYM4_API DWORD __stdcall PlayM4_GetFileTotalFrames(LONG nPort);
PLAYM4_API DWORD __stdcall PlayM4_GetCurrentFrameRate(LONG nPort);
PLAYM4_API DWORD __stdcall PlayM4_GetPlayedTimeEx(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_SetPlayedTimeEx(LONG nPort,DWORD nTime);
PLAYM4_API DWORD __stdcall PlayM4_GetCurrentFrameNum(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_SetCurrentFrameNum(LONG nPort,DWORD nFrameNum);
PLAYM4_API BOOL __stdcall PlayM4_GetSystemTime(LONG nPort, PLAYM4_SYSTEM_TIME *pstSystemTime);
PLAYM4_API DWORD __stdcall PlayM4_GetSpecialData(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_GetPictureSize(LONG nPort,LONG *pWidth,LONG *pHeight);
PLAYM4_API BOOL __stdcall PlayM4_SetFileEndCallback(LONG nPort, void(CALLBACK*FileEndCallback)(long nPort, void *pUser), void *pUser);
PLAYM4_API BOOL __stdcall PlayM4_GetFileTotalTime(LONG nPort, PLAYM4_SYSTEM_TIME *pstBegin, PLAYM4_SYSTEM_TIME *pstStop);
///<ʱıʾΪλΪΪ
PLAYM4_API BOOL __stdcall PlayM4_SetSupplementaryTimeZone(int nPort, int nTimeZone); 
///<Ѿʱ򷵻ʱʧ
PLAYM4_API BOOL __stdcall PlayM4_GetSupplementaryTimeZone(int nPort, int* pTimeZone); 
///<ȡʱϢ
PLAYM4_API int __stdcall PlayM4_GetTimeZoneInfo(long nPort, int* pTimeZone);
//ȡװͱ
PLAYM4_API int __stdcall PlayM4_GetStreamInfo(long nPort, int* pSysFormat, int* pCodeType);
///<
PLAYM4_API DWORD __stdcall PlayM4_GetSourceBufferRemain(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_ResetSourceBuffer(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_SetSourceBufCallBack(LONG nPort,DWORD nThreShold,void (CALLBACK * SourceBufCallBack)(long nPort,DWORD nBufSize,void* dwUser,void*pResvered),void* dwUser,void *pReserved);
PLAYM4_API BOOL __stdcall PlayM4_ResetSourceBufFlag(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_ResetBuffer(LONG nPort,DWORD nBufType);
PLAYM4_API DWORD __stdcall PlayM4_GetBufferValue(LONG nPort,DWORD nBufType);
PLAYM4_API BOOL __stdcall PlayM4_SetDisplayBuf(LONG nPort,DWORD nNum);
PLAYM4_API DWORD __stdcall PlayM4_GetDisplayBuf(LONG nPort);

///<ץͼ
PLAYM4_API BOOL __stdcall PlayM4_SetJpegQuality(long nQuality);
PLAYM4_API BOOL __stdcall PlayM4_GetBMP(LONG nPort,PBYTE pBitmap,DWORD nBufSize,DWORD* pBmpSize);
PLAYM4_API BOOL __stdcall PlayM4_GetJPEG(LONG nPort,PBYTE pJpeg,DWORD nBufSize,DWORD* pJpegSize);
PLAYM4_API BOOL __stdcall PlayM4_ConvertToBmpFile(char * pBuf,long nSize,long nWidth,long nHeight,long nType,char *sFileName);
PLAYM4_API BOOL __stdcall PlayM4_ConvertToJpegFile(char * pBuf,long nSize,long nWidth,long nHeight,long nType,char *sFileName);

///< ýģʽ
PLAYM4_API BOOL __stdcall PlayM4_SetDemuxModel(LONG nPort, unsigned int nIdemuxType, BOOL bTrue);
PLAYM4_API BOOL __stdcall PlayM4_SetIdemuxPara(LONG nPort, int nChunkSize);

///<
PLAYM4_API BOOL __stdcall PlayM4_SetSecretKey(LONG nPort, LONG lKeyType, char *pSecretKey, LONG lKeyLen);
PLAYM4_API BOOL __stdcall PlayM4_ThrowBFrameNum(LONG nPort,DWORD nNum);
PLAYM4_API BOOL __stdcall PlayM4_SetDecCBStream(LONG nPort,DWORD nStream);
PLAYM4_API BOOL __stdcall PlayM4_SetDecodeFrameType(LONG nPort,DWORD nFrameType);
PLAYM4_API BOOL __stdcall PlayM4_CheckDiscontinuousFrameNum(LONG nPort, BOOL bCheck);
PLAYM4_API BOOL __stdcall PlayM4_SkipErrorData(LONG nPort, BOOL bSkip);
//òصȼ-ȼԽߣԽ nLevelΧ[1,4],һ1
PLAYM4_API BOOL __stdcall PlayM4_SetDecodeERC(long nPort, unsigned int nLevel);
PLAYM4_API BOOL __stdcall PlayM4_SetDecCallBackMend(LONG nPort,void (CALLBACK* DecCBFun)(long nPort,char * pBuf,long nSize,FRAME_INFO * pFrameInfo, void* nUser,void* nReserved2), void* nUser);
PLAYM4_API BOOL __stdcall PlayM4_SetDecCallBackExMend(LONG nPort, void (CALLBACK* DecCBFun)(long nPort, char* pBuf, long nSize, FRAME_INFO* pFrameInfo, void* nUser, void* nReserved2), char* pDest, long nDestSize, void* nUser);
// ص,nType=0ʾܱλ仯ͻصnType=1ʾмλص-ֻصһ
PLAYM4_API BOOL __stdcall PlayM4_SetEncryptTypeCallBack(LONG nPort, DWORD nType, void (CALLBACK* EncryptTypeCBFun)(long nPort, ENCRYPT_INFO* pEncryptInfo, void* nUser, long nReserved2), void* nUser);

//ʾصоʱ֡ţʱ֡ţĻص;
// nModule ʾصģѡ0 ʾĬϽصʾص 1ʾص2ʾʾص
// nType ʾصʱ֡ţʱ֡ţã0ʾصʱ֡ 1: ʾصʱ;֡
//ʾصû֡Żصģʾص 0ʾصʱ 1: ʾصʱ
PLAYM4_API BOOL __stdcall PlayM4_SetDecOrDisplayCallbackType(int nPort, int nModule, int nType);


#define YUV_RGB24			        1		///<rgb
#define YUV_YUYV			     	2		///<YUYV
#define YUV_YV12					3		///<YV12,ſĬ
#define YUV_NV12			     	4		///<NV12

//nMode ʾű0ʾţԭֱ;0ʱnModeĸ2ֽڱʾ2ֽڱʾߣҪߺͿ128С8192
PLAYM4_API  int __stdcall PlayM4_SetYUVCallBackType(LONG nPort, DWORD nType, DWORD nMode);

///< YUV ʾصӿڣ֧ӲsurfaceתyuvݻصbTrueʾ·ҪƴӺٻصbTrue == 1ʱʾҪڲƴӣ
//bTrue == 0ʱʾҪڲƴӣ·ֱصȥע⣺ӥֻصһ·ȥ֧ӥ۵·ƴӻص
PLAYM4_API BOOL __stdcall PlayM4_SetDisplayCallBackYUV(LONG nPort, void (CALLBACK* DisplayCBFun)(DISPLAY_INFO_YUV *pstDisplayInfo), BOOL bTrue, void* pUser);

///<ʾ
PLAYM4_API BOOL __stdcall PlayM4_SetDisplayRegion(LONG nPort,DWORD nRegionNum, RECT *pSrcRect, HWND hDestWnd, BOOL bEnable);///<ӷŴ
PLAYM4_API BOOL __stdcall PlayM4_SetDisplayRegionOnWnd(LONG nPort,DWORD nRegionNum, RECT *pSrcRect, BOOL bEnable);///<രڷָ
PLAYM4_API BOOL __stdcall PlayM4_SetDisplayType(LONG nPort,LONG nType);
PLAYM4_API long __stdcall PlayM4_GetDisplayType(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_SetDisplayCallBack(LONG nPort,void (CALLBACK* DisplayCBFun)(long nPort,char * pBuf,long nSize,long nWidth,long nHeight,long nStamp,long nType,void* nReserved));
PLAYM4_API BOOL __stdcall PlayM4_SetDisplayCallBackEx(LONG nPort,void (CALLBACK* DisplayCBFun)(DISPLAY_INFO *pstDisplayInfo), void* nUser);
PLAYM4_API BOOL __stdcall PlayM4_RegisterDrawFun(LONG nPort,void (CALLBACK* DrawFun)(long nPort,HDC hDc,void* nUser),void* nUser);
PLAYM4_API BOOL __stdcall PlayM4_SetEncTypeChangeCallBack(LONG nPort,void(CALLBACK *funEncChange)(long nPort,void* nUser),void* nUser);
PLAYM4_API BOOL __stdcall PlayM4_SetCheckWatermarkCallBack(LONG nPort,void(CALLBACK* funCheckWatermark)(long nPort,WATERMARK_INFO* pWatermarkInfo,void* nUser),void* nUser);
PLAYM4_API BOOL __stdcall PlayM4_RenderPrivateData(LONG nPort, int nIntelType, BOOL bTrue);
PLAYM4_API BOOL __stdcall PlayM4_RenderPrivateDataEx(LONG nPort, int nIntelType, int nSubType, BOOL bTrue);
PLAYM4_API BOOL __stdcall PlayM4_SetOverlayPriInfoFlag(LONG nPort, int nIntelType, BOOL bTrue);
PLAYM4_API BOOL __stdcall PlayM4_SetTrackDurationTime(LONG nPort, int nTime);
//lType: 1 ʾȡǰʾ֡PTZϢضṹʽ洢pInfoڣplLenسϢ;ȴpInfo = nullԻȡҪڴ泤plLen
PLAYM4_API BOOL __stdcall PlayM4_GetStreamAdditionalInfo(LONG nPort, LONG lType, BYTE* pInfo, LONG* plLen);

//˽ϢصӿڣnTypeʾҪص˽ϢͣĿǰ֧: ͨĿ1; Ŀ 2; ֧ 1|2 ʽ3ʾͶص
PLAYM4_API BOOL __stdcall PlayM4_RegisterIVSDrawFunCB_EX(long nPort, void (CALLBACK* IVSDrawFun)(long nPort, HDC hDC, FRAME_INFO* pFrameInfo, INTEL_INFO_EX* pSyncData, void*  dwUser), void*  dwUser, unsigned int nType);

//˽Ϣصӿ,nStampʾʱϢpSyncDataʾ˽Ϣ, nTypeʾҪص˽Ϣֶ֧ͣ˽Ϣһã
//統nType6ʾⲿҪصĿͨ򣬴ʱſֻصͣҪصֱnType0ɣʱĬϢṹϢص
//nModeʾصעģʽ(ڽӿڵĹչ)0ʾ̻صſڲкƵ֡ƥ䣬ҲصHDCĿǰֻ֧0ģʽƥصģʽƥصHDCģʽ
PLAYM4_API BOOL __stdcall PlayM4_RegisterIVSIntelInfoCB(LONG nPort, void (CALLBACK* IVSIntelInfoCBFun)(LONG nPort, HDC hDC, LONG nStamp, PRIVATE_INFO* pSyncData, void*  dwUser), void* dwUser, DWORD nType, DWORD nMode);

///<ͼ
PLAYM4_API BOOL __stdcall PlayM4_SetColor(LONG nPort, DWORD nRegionNum, int nBrightness, int nContrast, int nSaturation, int nHue);
PLAYM4_API BOOL __stdcall PlayM4_GetColor(LONG nPort, DWORD nRegionNum, int *pBrightness, int *pContrast, int *pSaturation, int *pHue);
PLAYM4_API BOOL __stdcall PlayM4_SetImageSharpen(LONG nPort,DWORD nLevel);
PLAYM4_API BOOL __stdcall PlayM4_SetRotateAngle(LONG nPort, DWORD nRegionNum, DWORD dwType);

///<
PLAYM4_API DWORD __stdcall PlayM4_GetFileHeadLength();
PLAYM4_API DWORD __stdcall PlayM4_GetSdkVersion();
PLAYM4_API DWORD __stdcall PlayM4_GetLastError(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_SetSycGroup(LONG nPort, DWORD dwGroupIndex);
PLAYM4_API BOOL __stdcall PlayM4_MotionFlow(LONG nPort, DWORD dwAdjustType);

// ʱȡMP4װ߶λƫ
PLAYM4_API int __stdcall PlayM4_GetMpOffset(int nPort, int nTime, int* nOffset);

//Hlogд־ؽӿڡһportĿزԸýportáĿǰļ·ãΪܵչԤ
PLAYM4_API BOOL __stdcall PlayM4_SetHLogFlag(int nPort, BOOL bFlag, char* pConfigFilePath);

#ifndef PLAYM4_HIKD3D11_TAG
#define PLAYM4_HIKD3D11_TAG
///<Ӳֱ̽
#define HXVA_RESOLUTION_NONE   0x00      // 0
#define HXVA_RESOLUTION_200W   0x01      // 1920*1080
#define HXVA_RESOLUTION_300W   0x02      // 2048*1536
#define HXVA_RESOLUTION_500W   0x03      // 2560*1920
#define HXVA_RESOLUTION_800W   0x04      // 3840*2160
#define HXVA_RESOLUTION_1600W  0x05      // 4096*4096
#define HXVA_RESOLUTION_6400W  0x06      // 8192*8192(H.265)

///<ӲȾ̽ṹ
typedef struct _tagHDECODESUPPORT_
{
    unsigned char  chGPUType;                // GPUͣ 0-ޣ1-Nԣ2-Aԣ3-Intel
    unsigned char  bDXVA_D3D9;               // 0-֧֣1-֧
    unsigned char  bCUVID_D3D11;             // 0-֧֣1-֧
    unsigned char  chDXVAH264_Max_Resolution;// DXVA,h264ֵ֧ķֱʴֵ-Ǿ׼ֵ-嶨ö
    unsigned char  chDXVAH265_Max_Resolution;// DXVA,h265ֵ֧ķֱʴֵ-Ǿ׼ֵ-嶨ö
    unsigned char  chCUVIDH264_Max_Resolution;// CUVID,h264ֵ֧ķֱʴֵ-Ǿ׼ֵ-嶨ö
    unsigned char  chCUVIDH265_Max_Resolution;// CUVID,h265ֵ֧ķֱʴֵ-Ǿ׼ֵ-嶨ö
    unsigned char  chValidFlag;               ///<Ч
    unsigned char  bD3D11VA;                  // жǷ֧D3D11VAӲ:0-֧֣1-֧
    unsigned char  chD3D11VAH264_Max_Resolution;// D3D11VA,h264ֵ֧ķֱʴֵ-Ǿ׼ֵ
    unsigned char  chD3D11VAH265_Max_Resolution;// D3D11VA,h265ֵ֧ķֱʴֵ-Ǿ׼ֵ
    unsigned char  nReserved[9];        // ֶ
}HDECODESUPPORT;///< Ӳ֧Ϣ

typedef struct _tagRENDERSUPPORT_
{
    unsigned char  bDDraw;              ///< жǷ֧DrawȾ
    unsigned char  bD3D9Surface;        ///< жǷ֧D3D9Ⱦ
    unsigned char  bD3D9Texture;        ///< жǷ֧D3D9Ⱦ
    unsigned char  bD3D11;              ///< жǷ֧D3D11Ⱦ
    unsigned char  chValidFlag;         ///< Ч
    unsigned char  nGPUType;            ///< Ⱦ̽GPU  0-; 1-Intel;2-NVIDIA;3-AMD
    unsigned char  nReserved[10];       ///< ֶ
}RENDERSUPPORT;///< Ⱦ֧Ϣ

typedef struct _tagENGINESUPPORT_
{
    HDECODESUPPORT stHDecodeSupport; ///<Ӳ
    RENDERSUPPORT  stRenderSupport;  ///<Ⱦ
    unsigned int   chReserved[4];    ///<ֶ
}ENGINESUPPORT;///< ӲȾ֧

typedef struct _tagENGINESUPPORT_EX_
{
    HDECODESUPPORT stHDecodeSupportD3D9[8];
    HDECODESUPPORT stHDecodeSupportD3D11[8];
    RENDERSUPPORT  stRenderSupport[8];
    unsigned char  chD3D9DeviceCount;
    unsigned char  chD3D11DeviceCount;
    unsigned char  chRenderDeviceCount;
    unsigned char  chReserved[13];
}ENGINESUPPORT_EX;///< ӲȾ֧-EX

typedef struct _AUDIOCARDINFO_
{
    unsigned int  nDeviceIndex;     //豸
    char          sDeviceName[128]; //豸
    void          *pDevice;         //豸ַ
    unsigned char nReserved[8];     //ֶ
}AUDIOCARDINFO;

typedef struct _tagAUDIODEVICEPARAM_
{
    AUDIOCARDINFO  stAudioCardInfo[8];  ///<豸Ϣ
    unsigned char  chAudioCardCount;    ///<豸֧8
    unsigned char  chReserved[7];       ///<ֶ

}AUDIODEVICEPARAM;///< Ƶ豸̽Ϣ

///<d3d11Ⱦץͼṹ
typedef struct _tagD3D11_PIC_INFO_
{
    unsigned int   nPicMode;     //ץͼģʽ0-ʵʷֱץͼ(֮ǰץͼģʽ)1-洫ĿץͼnPicWidth*nPicHeightΪʾڿʱЧѣ
    unsigned char* pBuf;         //ץͼbuffer
    unsigned int   nBufSize;     //bufferС-nPicModeΪ0Ϊ֮ǰĸݻȡֱл룻nPicModeΪ1ϲõķֱ뻺棩
    unsigned int*  pPicSize;     //ʵͼƬС
    unsigned int   nPicWidth;    //ץͼ-nPicModeΪ1ʱЧҿ>=32,nPicWidth*nPicHeight<5000wֱʡ
    unsigned int   nPicHeight;   //ץͼ-nPicModeΪ1ʱЧҸ>=32,nPicWidth*nPicHeight<5000wֱʡ
    unsigned char  chReserve[8]; //reserveֶ
}D3D_PIC_INFO;

/*D3D11ͼ*/
typedef enum tagPLAYM4PostProcType
{
    PLAYM4_PPT_BRIGHTNESS               = 0x1,            ///<    [-1.0, 1.0]
    PLAYM4_PPT_HUE                      = 0x2,            ///< ɫ   [0.0, 1.0]----0.166ۼΪһɫ仯01Ϊͬһɫ
    PLAYM4_PPT_SATURATION               = 0x3,            ///< Ͷ [-1.0, 1.0]
    PLAYM4_PPT_CONTRAST                 = 0x4,            ///< Աȶ [-1.0, 1.0]
    PLAYM4_PPT_SHARPNESS                = 0x5,            ///<    [ 0.0, 1.0]
}PLAYM4PostProcType;

#endif

// DevcieţѡӦƵ豸ֻGetPort֮
PLAYM4_API BOOL __stdcall PlayM4_SetAudioDeviceIndex(LONG nPort, unsigned int nDeviceIndex);

PLAYM4_API BOOL __stdcall PlayM4_GetAudioDevice(LONG nPort, AUDIODEVICEPARAM* pstAudioDeviceParam);

///< ȡ豸ӲȾ--getport֮
PLAYM4_API int __stdcall PlayM4_GetEngineSupport(long nPort, ENGINESUPPORT* pstEngineSupport);

///<Ⱦd3d11ץͼ-ֻ֧d3d11ȾʱЧd3d9ȾЧ:nType:0-jpeg,1-bmp.
PLAYM4_API int __stdcall PlayM4_GetD3DCapture(long nPort, unsigned int nType, D3D_PIC_INFO* pstPicInfo);


///<d3d11ͼ-ֻ֧d3d11Ⱦ-ò
PLAYM4_API int __stdcall PlayM4_SetD3DPostProcess(long nPort, PLAYM4PostProcType nPostType, float fValue);

///<d3d11ͼ-ֻ֧d3d11Ⱦ-ȡ
PLAYM4_API int __stdcall PlayM4_GetD3DPostProcess(long nPort, PLAYM4PostProcType nPostType, float* fValue);

///<D3D11Ⱦʱ(D3D9ȾʱʵЧ)ַӵ·ʱĬ⣩-playǰ
PLAYM4_API int __stdcall PlayM4_SetConfigFontPath(int nPort, char* pFontPath);

////////////////////////////////////


///<SDPȡӿ//////////////////////////////////////////////////////////////////////////
#ifndef PLAYM4_SESSION_INFO_TAG
#define PLAYM4_SESSION_INFO_TAG

//nProtocolType
#define PLAYM4_PROTOCOL_RTSP    1
//nSessionInfoType
#define PLAYM4_SESSION_INFO_SDP 1

typedef struct _PLAYM4_SESSION_INFO_   //Ϣṹ
{
    int            nSessionInfoType;   //Ϣͣʱֻ֧SDP
    int            nSessionInfoLen;    //Ϣ
    unsigned char* pSessionInfoData;   //Ϣ
} PLAYM4_SESSION_INFO;
#endif

PLAYM4_API BOOL __stdcall PlayM4_OpenStreamAdvanced(LONG nPort, int nProtocolType, PLAYM4_SESSION_INFO* pstSessionInfo, DWORD nBufPoolSize);

///<ؽӿ//////////////////////////////////////////////////////////////////////////
#ifndef FISH_EYE_TAG
#define FISH_EYE_TAG

// װ
typedef enum tagFECPlaceType
{
    FEC_PLACE_WALL    = 0x1,        // װʽ     (ˮƽ)
    FEC_PLACE_FLOOR   = 0x2,        // 氲װ     ()
    FEC_PLACE_CEILING = 0x3,        // װʽ     ()

}FECPLACETYPE;

typedef enum tagFECCorrectType
{
    FEC_CORRECT_NULL                    = 0x0000, //  - (ԭͼ)
    FEC_CORRECT_PTZ                     = 0x0100, // PTZ
    FEC_CORRECT_180                     = 0x0200, // 180Ƚ - Ӧ2P - װ/װ
    FEC_CORRECT_360                     = 0x0300, // 360ȫ - Ӧ1P - װ/װ
    FEC_CORRECT_LAT                     = 0x0400, // γչ - װ
    FEC_CORRECT_SEMISPHERE              = 0x0500, // ۰ - ()
    FEC_CORRECT_CYLINDER                = 0x0600, // Բʾ - װ/װ
    FEC_CORRECT_CYLINDER_SPLIT          = 0x0700, // пԲʾ - װ/װ
    FEC_CORRECT_PLANET                  = 0x0800, // С
    FEC_CORRECT_ARCSPHERE_HORIZONTAL    = 0x0900, // ˮƽ - װ
    FEC_CORRECT_ARCSPHERE_VERTICAL      = 0x0A00, // ۴ֱ - װ
}FECCORRECTTYPE;

typedef enum tagFECCorrectEffect
{
    FEC_CORRECT_EFFECT_BACK_FACE_CULLING    = 0x100,        // ޳0ʾãΪ0ʾãǿת

}FECCORRECTEFFECT;

typedef struct tagCycleParam
{
    float   fRadiusLeft;    // ԲX
    float   fRadiusRight;   // ԲұX
    float   fRadiusTop;     // ԲϱY
    float   fRadiusBottom;  // Բ±Y

}CYCLEPARAM;

typedef struct tagPTZParam
{
    float fPTZPositionX;        // PTZ ʾλ X
    float fPTZPositionY;        // PTZ ʾλ Y	

}PTZPARAM;

#define         FEC_UPDATE_RADIUS            0x1
#define         FEC_UPDATE_PTZZOOM           0x2
#define         FEC_UPDATE_WIDESCANOFFSET    0x4
#define         FEC_UPDATE_PTZPARAM          0x8
#define         FEC_UPDATT_PTZCOLOR          0x10
#define         FEC_UPDATE_PTZSELECT         0x20

// ɫʽṹ
typedef struct tagFECColor
{
    unsigned char nR;     // R
    unsigned char nG;	  // G
    unsigned char nB;     // B
    unsigned char nAlpha; // Alpha
}FECCOLOR;

//PTZѡṹ
typedef struct tagFECRectF
{
    float fTop;
    float fBottom;
    float fLeft;
    float fRight;
}FECRECTF;

typedef struct tagFECParam
{
    unsigned int    nUpDateType;            // µ
    unsigned int    nPlaceAndCorrect;       // װʽͽʽֻڻȡSetParamʱЧ,ֵʾװʽͽʽĺ
    PTZPARAM        stPTZParam;             // PTZ УĲ
    CYCLEPARAM      stCycleParam;           // ͼԲĲ
    float           fZoom;                  // PTZ ʾķΧ
    float           fWideScanOffset;        // 180360УƫƽǶ
    FECCOLOR        stPTZColor;             // PTZɫ
    FECRECTF        stPTZSelct;             // PTZѡ
    unsigned int    nCut;                   //ԭͼǷвüڣԭͼ
    int             nResver[10];            // ֶ
}FISHEYEPARAM;

// PTZԭʼͼʾģʽ
typedef enum tagFECShowMode
{
    FEC_PTZ_OUTLINE_NULL,   // ʾ
    FEC_PTZ_OUTLINE_RECT,   // ʾ
    FEC_PTZ_OUTLINE_RANGE,  // ʵʾ
}FECSHOWMODE;

#define    FEC_JPEG   0  // JPEGץͼ
#define    FEC_BMP    1  // BMP ץͼ

// Ӳ־
#define FEC_DISPLAYSURFACE          0x400  // Ӳʶ

// תԪṹ
typedef struct tagPLAYM4SRTransformElement
{
    float fAxisX;
    float fAxisY;
    float fAxisZ;
    float fValue; // תĽǶ

}PLAYM4SRTRANSFERELEMENT;

// תϲ
typedef struct tagPLAYM4SRTransformParam
{
    PLAYM4SRTRANSFERELEMENT* pTransformElement;		// ת
    unsigned int		     nTransformCount;		// תϴ
}PLAYM4SRTRANSFERPARAM;


//////////*************صĲʹýӿںͶ()************************//////////////

#define FEC_DISPLAYSPHERE           0x402  // Ⱦʾ()-ʹ

PLAYM4_API BOOL __stdcall PlayM4_FEC_Rotate(LONG nPort, PLAYM4SRTRANSFERPARAM *pstRotateParam);///<˽ӿΪʹýӿ(תӿ)

//////////////////////**************************/////////////////////////


// ӽǱ任
typedef enum tagPLAYM4HRViewParamType
{
    PLAYM4_HR_VPT_ROTATION_X       = 0x1,          ///<ˮƽת
    PLAYM4_HR_VPT_ROTATION_Y       = 0x2,          ///<ֱת
    PLAYM4_HR_VPT_SCALE            = 0x3,          ///<(ֵΪ0ֵʱΪ-Ч)
}PLAYM4HRVIEWPARAMTYPE;

// 3DģͲ
typedef enum tagPLAYM4FEC3DModelParam
{
    PLAYM4_FEC_3DMP_CYLINDER_HEIGHT              = 0x1,       ///< Բģ͸
    PLAYM4_FEC_3DMP_CYLINDER_RADIUS              = 0x2,       ///< ԲģͰ뾶
}PLAYM4FEC3DMODELPARAM;

// ضӽ״̬
typedef enum tagPLAYM4FECSpecialViewType
{
    PLAYM4_FEC_SVT_EDGE                          = 0x1        ///<ģ봰ӽ
}PLAYM4FECSPECIALVIEWTYPE;

typedef void (__stdcall* FISHEYE_CallBack )( void* pUser, unsigned int nSubPort, unsigned int nCBType, void* hDC, unsigned int nWidth, unsigned int nHeight);

#endif
// 
PLAYM4_API BOOL __stdcall PlayM4_FEC_Enable(LONG nPort);

// رģ
PLAYM4_API BOOL __stdcall PlayM4_FEC_Disable(LONG nPort);

// ȡ۽Ӷ˿ [1~31]
PLAYM4_API BOOL __stdcall PlayM4_FEC_GetPort(LONG nPort, unsigned int* nSubPort, FECPLACETYPE emPlaceType, FECCORRECTTYPE emCorrectType);

// ɾ۽Ӷ˿
PLAYM4_API BOOL __stdcall PlayM4_FEC_DelPort(LONG nPort, unsigned int nSubPort);

// ۽
PLAYM4_API BOOL __stdcall PlayM4_FEC_SetParam(LONG nPort, unsigned int nSubPort, FISHEYEPARAM* pPara);

// ȡ۽
PLAYM4_API BOOL __stdcall PlayM4_FEC_GetParam(LONG nPort, unsigned int nSubPort, FISHEYEPARAM* pPara);

// ʾڣʱл
PLAYM4_API BOOL __stdcall PlayM4_FEC_SetWnd(LONG nPort, unsigned int nSubPort, void* hWnd);

// ۴ڵĻͼص
PLAYM4_API BOOL __stdcall PlayM4_FEC_SetCallBack(LONG nPort, unsigned int nSubPort, FISHEYE_CallBack cbFunc, void* pUser);

// ץͼ
PLAYM4_API BOOL __stdcall PlayM4_FEC_Capture(LONG nPort, unsigned int nSubPort, unsigned int nType, char* pFileName);

// Ӳ
PLAYM4_API BOOL __stdcall PlayM4_FEC_SetConfig(LONG nPort,unsigned int nType);

PLAYM4_API BOOL __stdcall PlayM4_FEC_GetCurrentPTZPort(LONG nPort, float fPositionX,float fPositionY, unsigned int *pnPort);

PLAYM4_API BOOL __stdcall PlayM4_FEC_SetCurrentPTZPort(LONG nPort, unsigned int nSubPort);

PLAYM4_API BOOL __stdcall PlayM4_FEC_SetPTZOutLineShowMode(LONG nPort,FECSHOWMODE nPTZShowMode);

PLAYM4_API int __stdcall PlayM4_FEC_PTZ2Window(LONG nPort, unsigned int nSubPort, PTZPARAM stPTZRefOrigin, PTZPARAM stPTZRefWindow, PTZPARAM stPTZWindow, float * fXWindow, float * fYWindow);

PLAYM4_API int __stdcall PlayM4_FEC_PTZ2WindowEx(LONG nPort , unsigned int nSubPortF,unsigned int nSubPortS,PTZPARAM stPTZRefOrigin , PTZPARAM stPTZRefWindow , PTZPARAM stPTZWindow , float * fXWindow , float * fYWindow);

PLAYM4_API int __stdcall PlayM4_FEC_Scan(LONG nPort, unsigned int nSubPort, float fAngle, float* fXWindow, float* fYWindow, FECPLACETYPE emType);


//µ۰ӽǱ仯(ת)ؽӿ
//ȡӽǲ(ǰȻȡǰֵ)
PLAYM4_API BOOL __stdcall PlayM4_FEC_GetViewParam(LONG nPort, unsigned int nSubPort, PLAYM4HRVIEWPARAMTYPE enViewParamType, float* fValue);
//ðӽǱ仯(õֵΪȡֵҪƫֵ)
PLAYM4_API BOOL __stdcall PlayM4_FEC_SetViewParam(LONG nPort, unsigned int nSubPort, PLAYM4HRVIEWPARAMTYPE enViewParamType, float fValue);

//۵ӷŴ nType = 0
//۴ڷָ nType = 1
//ע⣬ڷָʱhDestWndЧΪNULL20180813ݲ֧֣
//ĿǰӷŴ֧ϷŴnRegionNumΪ0hDestWndΪNULLbEnableΪ0ȡӷŴ󣬷0ΪӷŴ
//pSrcRectһ1000Կ߸ߣֵ0-1000֮䣩
//ֻƼԭͼ180360γչеӷŴ-3D۲ʹô˽ӿ(ӽǱ仯ӿڽţptz3Dʽֵ֧ӷŴ
PLAYM4_API BOOL __stdcall PlayM4_FEC_SetDisplayRegion(LONG nPort, unsigned int nSubPort,unsigned int nType, DWORD nRegionNum, RECT *pSrcRect, HWND hDestWnd, BOOL bEnable);
//޳0ʾãΪ0ʾãǿת
PLAYM4_API BOOL __stdcall PlayM4_FEC_SetCorrectEffect(LONG nPort, unsigned int nSubPort, FECCORRECTEFFECT nCorrectEffect, float fValue);

// 3DģͲ-3DԲչЧ
PLAYM4_API BOOL __stdcall PlayM4_FEC_Set3DModelParam(int nPort, unsigned int nSubPort, PLAYM4FEC3DMODELPARAM enType, float fValue);

// ȡضӽǲ - ֻڻ棬SetViewParamӿʹ
PLAYM4_API BOOL __stdcall PlayM4_FEC_GetSpecialViewParam(int nPort, unsigned int nSubPort, PLAYM4FECSPECIALVIEWTYPE enSVType, PLAYM4HRVIEWPARAMTYPE enVPType, float* pValue);

///<ͼǿؽӿ//////////////////////////////////////////////////////////////////////////
#ifndef PLAYM4_HIKVIE_TAG
#define PLAYM4_HIKVIE_TAG

typedef struct _PLAYM4_VIE_DYNPARAM_
{
    int moduFlag;      //õ㷨ģ飬PLAYM4_VIE_MODULESж壬 PLAYM4_VIE_MODU_ADJ | PLAYM4_VIE_MODU_EHANģú󣬱ӦĲ
    //PLAYM4_VIE_MODU_ADJ
    int brightVal;     //ȵֵ[-255, 255]
    int contrastVal;   //Աȶȵֵ[-256, 255]
    int colorVal;      //Ͷȵֵ[-256, 255]
    //PLAYM4_VIE_MODU_EHAN
    int toneScale;     //˲Χ[0, 100]
    int toneGain;      //ԱȶȵڣȫֶԱȶֵ[-256, 255]
    int toneOffset;    //ȵڣƽֵƫƣ[-255, 255]
    int toneColor;     //ɫڣɫֵ[-256, 255]
    //PLAYM4_VIE_MODU_DEHAZE
    int dehazeLevel;   //ȥǿȣ[0, 255]
    int dehazeTrans;   //͸ֵ[0, 255]
    int dehazeBright;  //Ȳ[0, 255]
    //PLAYM4_VIE_MODU_DENOISE
    int denoiseLevel;  //ȥǿȣ[0, 255]
    //PLAYM4_VIE_MODU_SHARPEN
    int usmAmount;     //ǿȣ[0, 255]
    int usmRadius;     //񻯰뾶[1, 15]
    int usmThreshold;  //ֵ[0, 255]
    //PLAYM4_VIE_MODU_DEBLOCK
    int deblockLevel;  //ȥǿȣ[0, 100]
    //PLAYM4_VIE_MODU_LENS
    int lensWarp;      //[-256, 255]
    int lensZoom;      //[-256, 255]
    //PLAYM4_VIE_MODU_CRB
    //Ӧ
} PLAYM4_VIE_PARACONFIG;

typedef enum _PLAYM4_VIE_MODULES
{
    PLAYM4_VIE_MODU_ADJ      = 0x00000001, //ͼ
    PLAYM4_VIE_MODU_EHAN     = 0x00000002, //ֲǿģ
    PLAYM4_VIE_MODU_DEHAZE   = 0x00000004, //ȥģ
    PLAYM4_VIE_MODU_DENOISE  = 0x00000008, //ȥģ
    PLAYM4_VIE_MODU_SHARPEN  = 0x00000010, //ģ
    PLAYM4_VIE_MODU_DEBLOCK  = 0x00000020, //ȥ˲ģ
    PLAYM4_VIE_MODU_CRB      = 0x00000040, //ɫƽģ
    PLAYM4_VIE_MODU_LENS     = 0x00000080, //ͷģ
}PLAYM4_VIE_MODULES;
#endif

//ùر/ģ
//dwModuFlagӦPLAYM4_VIE_MODULES,
//ģ鿪ģڼĬϵĲ;
//رģϴõĲ
//ӿڵãڸýӿڿģ󣻷򣬷ش
PLAYM4_API BOOL __stdcall PlayM4_VIE_SetModuConfig(LONG lPort,int nModuFlag,BOOL bEnable);

//ͼǿNULLȫͼȫͼȫͼС32*32
//֧Ƚ˵4һ汾ֻ֧һҪصصͱ
PLAYM4_API BOOL __stdcall PlayM4_VIE_SetRegion(LONG lPort,LONG lRegNum,RECT* pRect);

//ȡģ
PLAYM4_API BOOL __stdcall PlayM4_VIE_GetModuConfig(LONG lPort,int* pdwModuFlag);

//òδģĲñ
PLAYM4_API BOOL __stdcall PlayM4_VIE_SetParaConfig(LONG lPort,PLAYM4_VIE_PARACONFIG* pParaConfig);

//ȡģĲ
PLAYM4_API BOOL __stdcall PlayM4_VIE_GetParaConfig(LONG lPort,PLAYM4_VIE_PARACONFIG* pParaConfig);

typedef struct
{
    long    lDataType;          //˽
    long    lDataStrVersion;    //ݷصĽṹ汾ҪΪ˼
    long    lDataTimeStamp;
    long    lDataLength;
    char*   pData;
}AdditionDataInfo;

PLAYM4_API BOOL __stdcall PlayM4_SetAdditionDataCallBack(LONG nPort, DWORD nSyncType, void (CALLBACK* AdditionDataCBFun)(long nPort, AdditionDataInfo* pstAddDataInfo, void* pUser), void* pUser);


#define SOFT_DECODE_ENGINE 0 ///<
#define HARD_DECODE_ENGINE 1 ///<Ӳ

PLAYM4_API BOOL  __stdcall PlayM4_SetDecodeEngineEx(LONG nPort, DWORD nDecodeEngine);
PLAYM4_API DWORD __stdcall PlayM4_GetDecodeEngine(LONG nPort);

#define PLAYM4_SOURCE_MODULE             0 // Դģ
#define PLAYM4_DEMUX_MODULE              1 // ģ
#define PLAYM4_DECODE_MODULE             2 // ģ
#define PLAYM4_RENDER_MODULE             3 // Ⱦģ
#define PLAYM4_MANAGER_MODULE            4 // ģ

#define PLAYM4_RTINFO_HARDDECODE_ERROR   0 // Ӳ(Ҫ)
#define PLAYM4_RTINFO_SOFTDECODE_ERROR   1 // ()
#define PLAYM4_RTINFO_MEDIAHEADER_ERROR  2 // ýͷ
#define PLAYM4_RTINFO_SWITCH_SOFT_DEC    3 // л
#define PLAYM4_RTINFO_ALLOC_MEMORY_ERROR 4 // ڴʧ
#define PLAYM4_RTINFO_ENCRYPT_ERROR      5 // Կ [ܵڽʱҲصô]
#define PLAYM4_RTINFO_RENDER_OVER        8 // Ⱦһ֡
#define PLAYM4_RTINFO_ERR_PRESENT             16 // Ⱦʾ[ǰȾȾʧ,ϲл]
#define PLAYM4_RTINFO_IDMX_DATA_ERROR         32 // ,ʧ
#define PLAYM4_RTINFO_DECODE_PARAM_ERROR      64 // ,ʧ
#define PLAYM4_RTINFO_SOFTDECODE_DATA_ERROR   128 // ݴ
#define PLAYM4_RTINFO_IDMX_PSH_PSM_ERROR         0x100// PSH/PSM,ʧ
#define PLAYM4_RTINFO_IDMX_RTP_HEADER_ERROR      0x200// RTPͷ󣬰չͷ
#define PLAYM4_RTINFO_IDMX_RTP_HEADER_SEQ_ERROR  0x400// RTPƵ
#define PLAYM4_RTINFO_IDMX_REDUNDANT_ERROR       0x800// 
#define PLAYM4_RTINFO_IDMX_MEDIA_CHANGE_ERROR             0x1000// ýϢı(hikͷϢһ»psmƵͷı)
#define PLAYM4_RTINFO_IDMX_DIFFERENT_FRAMERATE_ERROR      0x2000// װ֡֡ʲһ
#define PLAYM4_RTINFO_IDMX_DIFFERENT_RESOLUTION_ERROR     0x4000// װֱֱʲһ
#define PLAYM4_RTINFO_IDMX_DECORD_ERROR                   0x8000// 쳣
#define PLAYM4_RTINFO_IDMX_PRIVT_LEN_ERROR                0x10000// ˽ݳ쳣
#define PLAYM4_RTINFO_SOFTDECODE_DATA_FLAKE_ERROR         0x20000 //ݴڻ
#define PLAYM4_RTINFO_RTINFO_SOURCE_DATA_INTERVAL         0x40000
#define PLAYM4_RTINFO_MANAGER_SYC_LONG_WAIT               0x80000 //ͬȴϢ

typedef struct
{
    int            nRunTimeModule;     //ǰģ
    int            nStrVersion;        //ṹ汾
    int            nFrameTimeStamp;    //֡
    int            nFrameNum;          //ʱ
    int            nErrorCode;         //״̬-ǶǴϢ
    unsigned char  reserved[12];       //ֽ
}RunTimeInfo;

// ҪͬģĻصΪͬһעĽǵע
PLAYM4_API BOOL __stdcall PlayM4_SetRunTimeInfoCallBackEx(LONG nPort, int nModule, void (CALLBACK* RunTimeInfoCBFun)(long nPort, RunTimeInfo* pstRunTimeInfo, void* pUser), void* pUser);

// 1SetRunTimeInfoCallBackExӿڣnErrorCode6Ϊ8Ժչʽ 163264Ҵ8ʼϢĬϹرղ͡
// 2ʵʱϢƽӿڣƴ8ԺϢִ֧8ʼϢƴģʽ 8|16|32 ַʽϲѡ͡
// 3nTypeͨķʽʹ룬nFlagʾΪ0߽лص0
PLAYM4_API int __stdcall PlayM4_SetRunTimeInfoCallbackType(int nPort, int nModule, unsigned int nType, int nFlag);


#ifndef PLAYM4_HIKSR_TAG
#define PLAYM4_HIKSR_TAG

#define CFG_DISPLAY_MODEL_MODE         0x499

// ģͼ 0 ˫ 1  2  
typedef enum tagPLAYM4SRTextureMode
{
    PLAYM4_TEXTURE_DOUBLE       = 0x0,           // ˫
    PLAYM4_TEXTURE_OUTER        = 0x1,           // 
    PLAYM4_TEXTURE_INNER        = 0x2,           // ڱ
}PLAYM4SRTEXTUREMODE;

//ģ
typedef enum tagPLAYM4SRModelType
{
    PLAYM4_MODELTYPE_HEMISPHERE = 0x0,           //Ƶðģ
    PLAYM4_MODELTYPE_EAGLE_EYE  = 0x1,           //״ģӥƴ
    PLAYM4_MODELTYPE_CUBE       = 0x2,           //ģ
}PLAYM4SRMODELTYPE;

#define PLAYM4_MODEL_SOLID      0x0001           //ʵģ
#define PLAYM4_MODEL_FRAME      0x0010           //߿ģ
#define PLAYM4_MODEL_AXIS       0x0100           //

//Ⱦ3Dģ͵ز
typedef struct tagRenderModelMode
{
    bool                          bModelMode;      // ǷȾ3Dģ
    PLAYM4SRTEXTUREMODE           emTextureMode;   // ͼģʽ ˫  ڱ
    unsigned long                 ulDisplayType;   // λ SR_MODEL_SOLID | SR_MODEL_FRAME | SR_MODEL_AXIS
    unsigned int                  nTransformMode;  // 0 ߿ģͱ任  1 ߿᲻ģͱ任
    PLAYM4SRMODELTYPE             emModelType;     // ģͣ۰ӥģ͵
}PLAYM4SRMODELMODE;

#define SR_JPEG    0
#define SR_BMP     1

#endif


PLAYM4_API BOOL __stdcall PlayM4_SR_SetConfig(LONG nPort, int nCfgType, void *pValue);

PLAYM4_API BOOL __stdcall PlayM4_SR_Rotate(LONG nPort, PLAYM4SRTRANSFERPARAM *pstRotateParam);

PLAYM4_API BOOL __stdcall PlayM4_SR_Capture(LONG nPort, unsigned int nType, char *pFileName);



///<Ԥ¼ؽӿ//////////////////////////////////////////////////////////////////////////
#define PLAYM4_MEDIA_HEAD     1   //ϵͳͷ
#define PLAYM4_VIDEO_DATA     2   //Ƶ
#define PLAYM4_AUDIO_DATA     3   //Ƶ
#define PLAYM4_PRIVT_DATA     4   //˽

//Ԥ¼Ϣ
typedef struct  
{
    long nType;                     // ͣļͷƵƵ˽ݵ
    long nStamp;                    // ʱ
    long nFrameNum;                 // ֡
    long nBufLen;                   // ݳ
    char* pBuf;                     // ֡ݣ֡Ϊλص
    PLAYM4_SYSTEM_TIME  stSysTime;  // ȫʱ
}RECORD_DATA_INFO;

/////////////////////////////////////////////////////////////////////////////////////////////
//Unproposed Interface ʹõĽӿ
/////////////////////////////////////////////////////////////////////////////////////////////
PLAYM4_API BOOL __stdcall PlayM4_RigisterDrawFun(LONG nPort,void (CALLBACK* DrawFun)(long nPort,HDC hDc,void* nUser),void* nUser);
PLAYM4_API BOOL __stdcall PlayM4_SetDecCallBack(LONG nPort,void (CALLBACK* DecCBFun)(long nPort,char * pBuf,long nSize,FRAME_INFO * pFrameInfo, void* nReserved1,void* nReserved2));
PLAYM4_API BOOL __stdcall PlayM4_SetDecCallBackEx(LONG nPort,void (CALLBACK* DecCBFun)(long nPort,char * pBuf,long nSize,FRAME_INFO * pFrameInfo, void* nReserved1,void* nReserved2), char* pDest, long nDestSize);
PLAYM4_API BOOL __stdcall PlayM4_SetSycStartTime(LONG nPort, PLAYM4_SYSTEM_TIME *pstSystemTime);
PLAYM4_API BOOL __stdcall PlayM4_SyncToAudio(LONG nPort, BOOL bSyncToAudio);
PLAYM4_API BOOL __stdcall PlayM4_SetDecodeEngine(LONG nPort, DWORD nDecodeEngine);
PLAYM4_API BOOL __stdcall PlayM4_SetRunTimeInfoCallBack(LONG nPort, void (CALLBACK* RunTimeInfoCBFun)(long nPort, RunTimeInfo* pstRunTimeInfo, void* pUser), void* pUser);

/////////////////////////////////////////////////////////////////////////////////////////////
//Unsupported Interface ֵ֧Ľӿ
/////////////////////////////////////////////////////////////////////////////////////////////
//Ԥ¼񿪹أbFlag=1bFlag=0ر
PLAYM4_API BOOL __stdcall PlayM4_SetPreRecordFlag(LONG lPort, BOOL bFlag);
//Ԥ¼ݻص
PLAYM4_API BOOL __stdcall PlayM4_SetPreRecordCallBack(LONG lPort, void (CALLBACK* PreRecordCBfun)(long nPort, RECORD_DATA_INFO* pRecordDataInfo, void* pUser), void* pUser);
PLAYM4_API BOOL __stdcall PlayM4_InitDDraw(HWND hWnd);
PLAYM4_API BOOL __stdcall PlayM4_RealeseDDraw();
PLAYM4_API BOOL __stdcall PlayM4_SetFileEndMsg(LONG nPort,HWND hWnd,UINT nMsg);
PLAYM4_API int  __stdcall PlayM4_GetCaps();
PLAYM4_API BOOL __stdcall PlayM4_SetOverlayMode(LONG nPort,BOOL bOverlay,COLORREF colorKey);
PLAYM4_API LONG __stdcall PlayM4_GetOverlayMode(LONG nPort);
PLAYM4_API COLORREF __stdcall PlayM4_GetColorKey(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_InitDDrawDevice();
PLAYM4_API void __stdcall PlayM4_ReleaseDDrawDevice();
PLAYM4_API DWORD __stdcall PlayM4_GetDDrawDeviceTotalNums();
PLAYM4_API BOOL __stdcall PlayM4_SetDDrawDevice(LONG nPort,DWORD nDeviceNum);
PLAYM4_API BOOL __stdcall PlayM4_GetDDrawDeviceInfo(DWORD nDeviceNum,LPSTR  lpDriverDescription,DWORD nDespLen,LPSTR lpDriverName ,DWORD nNameLen,HMONITOR *hhMonitor);
PLAYM4_API int  __stdcall PlayM4_GetCapsEx(DWORD nDDrawDeviceNum);
PLAYM4_API BOOL __stdcall PlayM4_SetDDrawDeviceEx(LONG nPort,DWORD nRegionNum,DWORD nDeviceNum);
PLAYM4_API BOOL __stdcall PlayM4_OpenStreamEx(LONG nPort,PBYTE pFileHeadBuf,DWORD nSize,DWORD nBufPoolSize);
PLAYM4_API BOOL __stdcall PlayM4_CloseStreamEx(LONG nPort);
PLAYM4_API BOOL __stdcall PlayM4_InputVideoData(LONG nPort,PBYTE pBuf,DWORD nSize);
PLAYM4_API BOOL __stdcall PlayM4_InputAudioData(LONG nPort,PBYTE pBuf,DWORD nSize);
PLAYM4_API BOOL __stdcall PlayM4_SetTimerType(LONG nPort,DWORD nTimerType,DWORD nReserved);
PLAYM4_API BOOL __stdcall PlayM4_GetTimerType(LONG nPort,DWORD *pTimerType,DWORD *pReserved);
PLAYM4_API BOOL __stdcall PlayM4_SetVerifyCallBack(LONG nPort, DWORD nBeginTime, DWORD nEndTime, void (__stdcall * funVerify)(long nPort, FRAME_POS * pFilePos, DWORD bIsVideo, DWORD nUser),  DWORD  nUser);
PLAYM4_API BOOL __stdcall PlayM4_SetAudioCallBack(LONG nPort, void (__stdcall * funAudio)(long nPort, char * pAudioBuf, long nSize, long nStamp, long nType, long nUser), long nUser);
PLAYM4_API BOOL __stdcall PlayM4_SetEncChangeMsg(LONG nPort,HWND hWnd,UINT nMsg);
PLAYM4_API BOOL __stdcall PlayM4_GetOriginalFrameCallBack(LONG nPort, BOOL bIsChange,BOOL bNormalSpeed,long nStartFrameNum,long nStartStamp,long nFileHeader,void(CALLBACK *funGetOrignalFrame)(long nPort,FRAME_TYPE *frameType, long nUser),long nUser);
PLAYM4_API BOOL __stdcall PlayM4_GetFileSpecialAttr(LONG nPort, DWORD *pTimeStamp,DWORD *pFileNum ,DWORD *pReserved);
PLAYM4_API BOOL __stdcall PlayM4_SetPlayMode(LONG nPort,BOOL bNormal);
PLAYM4_API BOOL __stdcall PlayM4_SetOverlayFlipMode(LONG nPort,BOOL bTrue);
PLAYM4_API BOOL __stdcall PlayM4_SetDeflash(LONG nPort,BOOL bDefalsh);
PLAYM4_API BOOL __stdcall PlayM4_SetPicQuality(LONG nPort,BOOL bHighQuality);
PLAYM4_API BOOL __stdcall PlayM4_GetPictureQuality(LONG nPort,BOOL *bHighQuality);
/////////////////////////////////////////////////////////////////////////////////////////////

PLAYM4_API BOOL __stdcall PlayM4_SetGlobalBaseTime(long nPort, PLAYM4_SYSTEM_TIME stGlobalBaseTime);

#endif //_PLAYM4_H_
